/*	###################################################################
	# @(#) UDO-Shell fr Windows
	# @(#) (c) 1996 by Dirk Hagedorn - Asmecke 1 - 59846 Sundern
	# @(#) mit Turbo C++ 3.1
	# Start:	01.07.1996
	# Version:	10.02.1997
	###################################################################	*/


#define  STRICT
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <commdlg.h>
#include <dir.h>
#include <bwcc.h>

#include "fsplit.h"
#include "udosh.h"



/*	##############################################################
	# Variablen und Typen
	##############################################################	*/
#define GUIGER	0
#define	GUIENG	1

static int guilang= GUIENG;


#define MAX_FILE_LEN	128


static const char *S_ASC= "ASCII";
static const char *S_HTM= "HTML";
static const char *S_TEX= "LaTeX";
static const char *S_HPH= "Helptag";
static const char *S_LDS= "Linuxdoc";
static const char *S_LYX= "LyX";
static const char *S_MAN= "Manpage";
static const char *S_NRO= "NROFF";
static const char *S_PCH= "Pure-C";
static const char *S_AQV= "QuickView";
static const char *S_RTF= "RTF";
static const char *S_STG= "ST-Guide";
static const char *S_INF= "Texinfo";
static const char *S_TVH= "Turbo-Vision";
static const char *S_WIN= "WinHelp";
static const char *S_SRC= "C";
static const char *S_SRP= "Pascal";

static const char *S_TRUE= "TRUE";
static const char *S_FALSE= "FALSE";


/* ------------------------------------------------------ */
/* Daten, die von der ersten Instanz initialisiert werden */
/* ------------------------------------------------------ */
typedef struct tagSETUPDATA
{
	char   szAppName[16];	/* App-Name */
}	SETUPDATA;

SETUPDATA SetUpData;

char cmufile[256];


/* ---------------------------------------------------- */
/* Config-Daten der INI-Datei							*/
/* ---------------------------------------------------- */

#define	UDOSH_INI		"udosh.ini"
#define	MAX_APP_LEN		128
#define	MAX_SUF_LEN		16
#define	MAX_UNIX_LEN	16
#define	MAX_LOWER_LEN	16

#define	DEST_APP	"DestApp"
#define	DEST_OPT	"DestOpt"
#define	DEST_UNIX	"DestUnix"
#define	DEST_EDIT	"DestEdit"
#define	DEST_LOWER	"DestLower"

#define	PARAM_APP	"ParamApp"
#define	PARAM_OPT	"ParamOpt"
#define	PARAM_SUF	"ParamSuf"
#define	PARAM_EDIT	"ParamEdit"
#define	PARAM_UNIX	"ParamUnix"
#define PARAM_LOWER	"ParamLower"

#define	FINAL_APP	"FinalApp"
#define	FINAL_OPT	"FinalOpt"
#define	FINAL_SUF	"FinalSuf"
#define	FINAL_EDIT	"FinalEdit"
#define	FINAL_UNIX	"FinalUnix"
#define	FINAL_LOWER "FinalLower"

typedef struct
{
	char	app_dest[MAX_APP_LEN+1];
	char	app_param[MAX_APP_LEN+1];
	char	app_final[MAX_APP_LEN+1];

	char	edi_dest[MAX_APP_LEN+1];
	char	edi_param[MAX_APP_LEN+1];
	char	edi_final[MAX_APP_LEN+1];

	char	opt_dest[MAX_APP_LEN+1];
	char	opt_param[MAX_APP_LEN+1];
	char	opt_final[MAX_APP_LEN+1];

	char	suf_param[MAX_SUF_LEN+1];
	char	suf_final[MAX_SUF_LEN+1];

	char	unix_dest[MAX_UNIX_LEN+1];
	char	unix_param[MAX_UNIX_LEN+1];
	char	unix_final[MAX_UNIX_LEN+1];

	char	lower_dest[MAX_LOWER_LEN+1];
	char	lower_param[MAX_LOWER_LEN+1];
	char	lower_final[MAX_LOWER_LEN+1];

	BOOL formconfig_changed;
}	FORMCONFIG;


typedef struct
{
	char	udo[MAX_APP_LEN+1];
	char	opt[MAX_APP_LEN+1];
	char	edi[MAX_APP_LEN+1];
	
	FORMCONFIG	asc, htm, tex, lds, man, nro, pch;
	FORMCONFIG	aqv, rtf, stg, tvh, inf, win;
	FORMCONFIG	hph, lyx, src, srp;

    BOOL	config_changed;
}	CONFIG;

CONFIG config;


/* ---------------------------------------------------- */
/* Daten, die vom Programm referenziert werden koennen, */
/* aber nicht zu anderen Instanzenten uebergeben werden */
/* ---------------------------------------------------- */
HINSTANCE	hInst;					/* App-Instanz			*/
HWND		hWndMain;				/* Main-Window-Handle	*/

char		fsource[MAX_FILE_LEN];	/* Quelldatei			*/
char		fdest[MAX_FILE_LEN];	/* Zieldatei			*/
char		fparam[MAX_FILE_LEN];	/* Zielparamterdatei	*/
char		fresult[MAX_FILE_LEN];	/* Zielparamterdatei	*/
char		flog[MAX_FILE_LEN];		/* Logdatei				*/
char		fhyp[MAX_FILE_LEN];		/* Hypdatei				*/
char		ftree[MAX_FILE_LEN];	/* Treedatei			*/
char		symbol[MAX_FILE_LEN];	/* -D Symbol			*/
char		symbol2[MAX_FILE_LEN];	/* -D Symbol			*/
char		symbol3[MAX_FILE_LEN];	/* -D Symbol			*/
BOOL		use_symbol1, use_symbol2, use_symbol3;
BOOL		use_log, use_hyp, use_tree;
BOOL		mode_test;
BOOL		mode_verb;
BOOL		mode_folder;
int			destformat;				/* Zielformat			*/
LPSTR		myCmdLine;

int			xChar, yChar, yCharnl;  // character size
int			xClient, yClient;       // client window size

HANDLE    	hdlgr;					/* Dialog-Resourcen-Handle	*/

FARPROC   	lpModelessProc;         // pointer to proc for modeless box
HWND      	hDialogBox;             // handle of modeless dialog box


/*	##############################################################
	# Prototypen
	##############################################################	*/

int	PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
						LPSTR lpszCmdLine, int cmdShow);

BOOL InitUdo(HINSTANCE hInstance, HINSTANCE hPrevInstance,
						LPSTR lpszCmdLine, int cmdShow);
BOOL InitUdoFirst(HINSTANCE hInstance);
void InitUdoAdded(HINSTANCE hPrevInstance);
BOOL InitUdoEvery(HINSTANCE hInstance, int cmdShow);
void CloseUdo(void);

void read_ini ( void );
void read_settings ( void );
void write_ini ( void );
void write_settings ( void );

LRESULT CALLBACK HandleMainWindow(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK HandleMainDialog(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);


BOOL InitMainDialog(HWND hWnd);


void adjust_buttons ( HWND hWnd );


//*******************************************************************
// WinMain - udosh main
//*******************************************************************
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
				   LPSTR lpszCmdLine, int cmdShow)
{
	MSG   msg;

	myCmdLine= lpszCmdLine;

	if (!InitUdo(hInstance, hPrevInstance, lpszCmdLine, cmdShow))
	{	return(0);
    }

	while ( GetMessage(&msg, NULL, 0, 0) )
	{
#if 0
		if	( !hDialogBox || !IsWindow(hDialogBox) ||
			!IsDialogMessage( hDialogBox, &msg))
#endif
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return(msg.wParam);
}


//*******************************************************************
// InitUdo
//*******************************************************************
#pragma argsused

BOOL InitUdo(HINSTANCE hInstance, HINSTANCE hPrevInstance,
			   LPSTR lpszCmdLine, int cmdShow)
{

	if (!hPrevInstance)              // if no previous instance, this is first
	{	if (!InitUdoFirst(hInstance))
		{	return(FALSE);
		}
    }
	else
	{	// Zwei Instanzen verhindern, da die Shell
    	// --- warum auch immer --- sonst abstrzt
		// InitUdoAdded(hPrevInstance);
        BringWindowToTop(NULL);
		return(FALSE);

    }

	if (!InitUdoEvery(hInstance, cmdShow))
	{	return(FALSE);
	}

    return(TRUE);
}

//*******************************************************************
// InitUdoFirst - done only for first instance of ffind
//*******************************************************************
BOOL InitUdoFirst(HINSTANCE hInstance)
{

	WNDCLASS wcUdoClass;
    BOOL success= TRUE;


	// Get string from resource with application name.
	if (0==LoadString(hInstance, IDS_NAME, (LPSTR) SetUpData.szAppName, 16))
	{	success= FALSE;
    }
	
	// Define the window class for this application.
	wcUdoClass.lpszClassName = SetUpData.szAppName;
	wcUdoClass.hInstance     = hInstance;
	wcUdoClass.lpfnWndProc   = HandleMainWindow;
	wcUdoClass.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wcUdoClass.hIcon         = LoadIcon(hInstance, "udosh");
	wcUdoClass.lpszMenuName  = (LPSTR) NULL;
	wcUdoClass.hbrBackground = GetStockObject(WHITE_BRUSH);
	wcUdoClass.style         = CS_HREDRAW | CS_VREDRAW;
	wcUdoClass.cbClsExtra    = 0;
	wcUdoClass.cbWndExtra    = 0;

    // Register the class
	if (!RegisterClass(&wcUdoClass))
	{	success= FALSE;
	}

    return (success);
}

//*******************************************************************
// InitUdoAdded - done only for added instances of ffind
//*******************************************************************
#pragma argsused

void InitUdoAdded(HINSTANCE hPrevInstance)
{
	// get the results of the initialization of first instance
	GetInstanceData(hPrevInstance, (BYTE *) &SetUpData, sizeof(SETUPDATA));
}

//*******************************************************************
// InitUdoEvery - done for every instance of ffind
//*******************************************************************
#pragma argsused

BOOL InitUdoEvery(HINSTANCE hInstance, int cmdShow)
{

	BOOL success= TRUE;

	hInst = hInstance;       // save for use by window procs

	// Create applications main window.
	hWndMain = CreateWindow(
                  SetUpData.szAppName,     // window class name
                  SetUpData.szAppName,     // window title
                  WS_BORDER |              // type of window
                    WS_CAPTION |
                    WS_SYSMENU |
                    WS_MINIMIZEBOX,
                  7,                       // x - same as dialog box
				  17,                      // y
				  298,                     // cx
				  222,                     // cy
				  NULL,                    // no parent for this window
				  NULL,	 				   // use the class menu
				  hInstance,               // who created this window
				  NULL                     // no parms to pass on
				  );

	if (hWndMain==NULL)
	{	success= FALSE;
    }
	
	// Create a thunk for the main dialog box proc function.
	lpModelessProc = MakeProcInstance((FARPROC) HandleMainDialog, hInst);

	if (lpModelessProc==NULL)
	{	success= FALSE;
    }

	if (!InitMainDialog(hWndMain))
	{	success= FALSE;
    }

    return(success);

}

//*******************************************************************
// CloseUdo - done at termination of every instance of ffind
//*******************************************************************
void CloseUdo()
{	write_settings();
	write_ini();
}


//*******************************************************************
// HandleMainWindow - handles messages for this application
//*******************************************************************
LRESULT CALLBACK HandleMainWindow(HWND hWnd, UINT message,
			     WPARAM wParam, LPARAM lParam)
{


    switch (message)
    {
        case WM_MOVE:
            // Move the dialog box on top of our main window every
			// time the main window moves.
			if (IsWindow(hDialogBox))
				SendMessage(hDialogBox, message, wParam, lParam);
            break;

        case WM_SETFOCUS:
            // Always set the input focus to the dialog box.
			if (IsWindow(hDialogBox))
				SendMessage(hDialogBox, message, wParam, lParam);
            break;

        case WM_CLOSE:
            // Tell windows to destroy our window.
			DestroyWindow(hWnd);
            break;

        case WM_QUERYENDSESSION:
            // If we return TRUE we are saying it's ok with us to end the
            // windows session.
			return((long) TRUE);  // we agree to end session.

		case WM_ENDSESSION:
			// If wParam is not zero, it meany every application said ok
            // to WM_QUERYENDSESSION messages, so we are really ending.
			if (wParam)           // if all apps aggreed to end session.
			{	CloseUdo();     // This is the end. We will not get a
            }
                                   // WM_DESTROY message on end session.
            break;

        case WM_DESTROY:
			CloseUdo();
            PostQuitMessage(0);
            break;

        default:
            return(BWCCDefWindowProc(hWnd, message, wParam, lParam));
    }

	return(0L);
}


//*******************************************************************
// InitMainDialog - put up modeless dialog box
//*******************************************************************
BOOL InitMainDialog(HWND hWnd)
{
    // This structure describes the fixed portion at the begining of a
    // dialog template. The part we are going to modify is dtItemCount
    // to cause the proper number of drive selector boxes to display.
    typedef struct tagDLGTEMPLATE
    {
        long dtStyle;
        BYTE dtItemCount;
        int  dtX;
		int  dtY;
        int  dtCX;
        int  dtCY;
        char dtResourceName[1];
    }   DLGTEMPLATE;
	DLGTEMPLATE FAR *dltp;

    BOOL success= TRUE;


    // Modifying dialog box parms on the fly.

    // Load the dialog box resource.
	hdlgr = LoadResource(
				hInst,
                FindResource(hInst, MAKEINTRESOURCE(DIALMAIN), RT_DIALOG));

	if (hdlgr)
    {
        // Lock the resource so we have a pointer to it.
        dltp = (DLGTEMPLATE FAR *) LockResource(hdlgr);
        if (dltp)
        {
			// Create the dialog box. Its proc is the next function down.
			if (!CreateDialogIndirect(hInst,
									  (LPSTR) dltp,
									  hWnd,
									  (DLGPROC) lpModelessProc))
			{
				// Unlock dialog resource we locked above.
				UnlockResource(hdlgr);

				// Free it.
				FreeResource(hdlgr);

				// Zero handle to it.
				hdlgr = 0;

                success= FALSE;
				MessageBox(hWnd, "Error:\nCouldn't create modeless dialog", "UDO Shell", MB_ICONSTOP | MB_OK);
			}
		}
		else
		{	success= FALSE;
			MessageBox(hWnd, "Error:\nCouldn't lock resource", "UDO Shell", MB_ICONSTOP | MB_OK);
        }
	}
	else
	{   success= FALSE;
		MessageBox(hWnd, "Error:\nCouldn't load ressource!", "UDO Shell", MB_ICONSTOP | MB_OK);
	}

    return (success);
}



/*********************************************************************
Quelldatei selektieren
**********************************************************************/
BOOL select_source_file( HWND hWnd, char *f )
{
	OPENFILENAME ofnTemp;
	DWORD Errval;	// Error value
	char buf[5];	// Error buffer
	char Errstr[50]="GetOpenFileName returned Error #";
	char szTemp[] = "UDO Files (*.u*)\0*.u*\0All Files (*.*)\0*.*\0";
	BOOL success= TRUE;

/*
Some Windows structures require the size of themselves in an effort to
provide backward compatibility with future versions of Windows.  If the
lStructSize member is not set the call to GetOpenFileName() will fail.
*/
	ofnTemp.lStructSize = sizeof( OPENFILENAME );
	ofnTemp.hwndOwner = hWnd;	// An invalid hWnd causes non-modality
	ofnTemp.hInstance = 0;
	ofnTemp.lpstrFilter = (LPSTR)szTemp;	// See previous note concerning string
	ofnTemp.lpstrCustomFilter = NULL;
	ofnTemp.nMaxCustFilter = 0;
	ofnTemp.nFilterIndex = 1;
	ofnTemp.lpstrFile = (LPSTR)cmufile;	// Stores the result in this variable
	ofnTemp.nMaxFile = sizeof( cmufile );
	ofnTemp.lpstrFileTitle = NULL;
	ofnTemp.nMaxFileTitle = 0;
	ofnTemp.lpstrInitialDir = NULL;
	ofnTemp.lpstrTitle = (guilang==GUIGER) ? "Quelldatei whlen..." : "Select UDO source file...";	// Title for dialog
	ofnTemp.Flags = OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST;
	ofnTemp.nFileOffset = 0;
	ofnTemp.nFileExtension = 0;
	ofnTemp.lpstrDefExt = "u*";
	ofnTemp.lCustData = NULL;
	ofnTemp.lpfnHook = NULL;
	ofnTemp.lpTemplateName = NULL;
/*
If the call to GetOpenFileName() fails you can call CommDlgExtendedError()
to retrieve the type of error that occured.
*/

	strcpy(cmufile, "*.u*");

	if(GetOpenFileName( &ofnTemp ) != TRUE)
	{
		Errval=CommDlgExtendedError();
		if(Errval!=0)	// 0 value means user selected Cancel
		{
			sprintf(buf,"%ld",Errval);
			strcat(Errstr,buf);
			MessageBox(hWnd,Errstr,"WARNING",MB_OK|MB_ICONSTOP);
		}

        success= FALSE;

	}
	else
	{	strcpy(f, cmufile);
    	success= TRUE;
	}

	InvalidateRect( hWnd, NULL, TRUE );	// Repaint to display the new name

    return (success);
}


/*********************************************************************
Zieldatei selektieren
**********************************************************************/
BOOL select_dest_file( HWND hWnd, char *f )
{
	OPENFILENAME ofnTemp;
	DWORD Errval;	// Error value
	char buf[5];	// Error buffer
	char Errstr[50]="GetOpenFileName returned Error #";
	char szTemp[] = "All Files (*.*)\0*.*\0";
	BOOL success= TRUE;

/*
Some Windows structures require the size of themselves in an effort to
provide backward compatibility with future versions of Windows.  If the
lStructSize member is not set the call to GetOpenFileName() will fail.
*/
	ofnTemp.lStructSize = sizeof( OPENFILENAME );
	ofnTemp.hwndOwner = hWnd;	// An invalid hWnd causes non-modality
	ofnTemp.hInstance = 0;
	ofnTemp.lpstrFilter = (LPSTR)szTemp;	// See previous note concerning string
	ofnTemp.lpstrCustomFilter = NULL;
	ofnTemp.nMaxCustFilter = 0;
	ofnTemp.nFilterIndex = 1;
	ofnTemp.lpstrFile = (LPSTR)cmufile;	// Stores the result in this variable
	ofnTemp.nMaxFile = sizeof( cmufile );
	ofnTemp.lpstrFileTitle = NULL;
	ofnTemp.nMaxFileTitle = 0;
	ofnTemp.lpstrInitialDir = NULL;
	ofnTemp.lpstrTitle = (guilang==GUIGER) ? "Zieldatei whlen..." : "Select destination file...";	// Title for dialog
	ofnTemp.Flags = 0 /*OFN_PATHMUSTEXIST*/;
	ofnTemp.nFileOffset = 0;
	ofnTemp.nFileExtension = 0;
	ofnTemp.lpstrDefExt = "*";
	ofnTemp.lCustData = NULL;
	ofnTemp.lpfnHook = NULL;
	ofnTemp.lpTemplateName = NULL;
/*
If the call to GetOpenFileName() fails you can call CommDlgExtendedError()
to retrieve the type of error that occured.
*/

	strcpy(cmufile, "*.*");

	if(GetOpenFileName( &ofnTemp ) != TRUE)
	{
		Errval=CommDlgExtendedError();
		if(Errval!=0)	// 0 value means user selected Cancel
		{
			sprintf(buf,"%ld",Errval);
			strcat(Errstr,buf);
			MessageBox(hWnd,Errstr,"WARNING",MB_OK|MB_ICONSTOP);
		}

        success= FALSE;

	}
	else
	{	strcpy(f, cmufile);
	}

	InvalidateRect( hWnd, NULL, TRUE );	// Repaint to display the new name

    return(success);
}



/*********************************************************************
Programm auswhlen
**********************************************************************/
BOOL select_program( HWND hWnd, const char *title, char *f )
{
	OPENFILENAME ofnTemp;
	DWORD Errval;	// Error value
	char buf[5];	// Error buffer
	char Errstr[50]="GetOpenFileName returned Error #";
	char szTemp[] = "Programs (*.exe;*.pif;*.com;*.bat)\0*.exe;*.pif;*.com;*.bat\0All Files (*.*)\0*.*";
	BOOL success= TRUE;

/*
Some Windows structures require the size of themselves in an effort to
provide backward compatibility with future versions of Windows.  If the
lStructSize member is not set the call to GetOpenFileName() will fail.
*/
	ofnTemp.lStructSize = sizeof( OPENFILENAME );
	ofnTemp.hwndOwner = hWnd;	// An invalid hWnd causes non-modality
	ofnTemp.hInstance = 0;
	ofnTemp.lpstrFilter = (LPSTR)szTemp;	// See previous note concerning string
	ofnTemp.lpstrCustomFilter = NULL;
	ofnTemp.nMaxCustFilter = 0;
	ofnTemp.nFilterIndex = 1;
	ofnTemp.lpstrFile = (LPSTR)cmufile;	// Stores the result in this variable
	ofnTemp.nMaxFile = sizeof( cmufile );
	ofnTemp.lpstrFileTitle = NULL;
	ofnTemp.nMaxFileTitle = 0;
	ofnTemp.lpstrInitialDir = NULL;
	ofnTemp.lpstrTitle = title;	// Title for dialog
	ofnTemp.Flags = OFN_PATHMUSTEXIST;
	ofnTemp.nFileOffset = 0;
	ofnTemp.nFileExtension = 0;
	ofnTemp.lpstrDefExt = "*.exe;*.pif;*.com;*.bat";
	ofnTemp.lCustData = NULL;
	ofnTemp.lpfnHook = NULL;
	ofnTemp.lpTemplateName = NULL;
/*
If the call to GetOpenFileName() fails you can call CommDlgExtendedError()
to retrieve the type of error that occured.
*/

	strcpy(cmufile, "*.exe;*.pif;*.com;*.bat");

	if(GetOpenFileName( &ofnTemp ) != TRUE)
	{
		Errval=CommDlgExtendedError();
		if(Errval!=0)	// 0 value means user selected Cancel
		{
			sprintf(buf,"%ld",Errval);
			strcat(Errstr,buf);
			MessageBox(hWnd,Errstr,"WARNING",MB_OK|MB_ICONSTOP);
		}

        success= FALSE;

	}
	else
	{	strcpy(f, cmufile);
	}

	InvalidateRect( hWnd, NULL, TRUE );	// Repaint to display the new name

    return(success);
}


/*********************************************************************
Benutzer fragen, ob er den Standardeditor benutzen will oder einen
eigenen, falls ein Format keinen Editor besitzt
**********************************************************************/
BOOL select_editor ( HWND hWnd, char *formprg, const char *title )
{
	char prg[512];
	int mbRet;

    if (guilang==GUIGER)
	{	mbRet= MessageBox(hWnd,
				"Soll der Standardeditor benutzt werden?\n"
				"Ja: Standardeditor benutzen\n"
				"Nein: Anderen Editor auswhlen\n",
				"UDO Shell",
           	 MB_ICONQUESTION | MB_YESNOCANCEL
				);
	}
	else
	{	mbRet= MessageBox(hWnd,
				"Do you want to use the standard editor?\n"
				"Yes: use standard editor\n"
				"No: select another editor\n",
				"UDO Shell",
           	 MB_ICONQUESTION | MB_YESNOCANCEL
				);
	}

	switch ( mbRet )
	{
		case IDYES:
			strcpy(formprg, config.edi);
            return(TRUE);
        case IDNO:
			if ( select_program(hWnd, title, prg) )
			{	strcpy(formprg, prg);
            	return(TRUE);
			}
            break;
	}

    return (FALSE);
}



/*	############################################################
	#
	# INI-Datei auslesen
	#
	############################################################	*/
void read_settings ( void )
{
	char s[MAX_APP_LEN+1];


	GetPrivateProfileString("Shell", "Source",  "", (LPSTR) (fsource), MAX_APP_LEN, UDOSH_INI);
	GetPrivateProfileString("Shell", "Dest",  "", (LPSTR) (fdest), MAX_APP_LEN, UDOSH_INI);

	GetPrivateProfileString("Shell", "Format",  "", (LPSTR) (s), MAX_APP_LEN, UDOSH_INI);

	if (strcmp(s, S_ASC)==0)	destformat= ID_DMAIN_ASC;
	if (strcmp(s, S_AQV)==0)	destformat= ID_DMAIN_AQV;
	if (strcmp(s, S_HTM)==0)	destformat= ID_DMAIN_HTM;
	if (strcmp(s, S_HPH)==0)	destformat= ID_DMAIN_HPH;
	if (strcmp(s, S_TEX)==0)	destformat= ID_DMAIN_TEX;
	if (strcmp(s, S_LDS)==0)	destformat= ID_DMAIN_LDS;
	if (strcmp(s, S_MAN)==0)	destformat= ID_DMAIN_MAN;
	if (strcmp(s, S_NRO)==0)	destformat= ID_DMAIN_NRO;
	if (strcmp(s, S_PCH)==0)	destformat= ID_DMAIN_PCH;
	if (strcmp(s, S_RTF)==0)	destformat= ID_DMAIN_RTF;
	if (strcmp(s, S_STG)==0)	destformat= ID_DMAIN_STG;
	if (strcmp(s, S_INF)==0)	destformat= ID_DMAIN_INF;
	if (strcmp(s, S_TVH)==0)	destformat= ID_DMAIN_TVH;
	if (strcmp(s, S_WIN)==0)	destformat= ID_DMAIN_WIN;
	if (strcmp(s, S_LYX)==0)	destformat= ID_DMAIN_LYX;
	if (strcmp(s, S_SRC)==0)	destformat= ID_DMAIN_SRC;
	if (strcmp(s, S_SRP)==0)	destformat= ID_DMAIN_SRP;

	GetPrivateProfileString("Shell", "Language",  "", (LPSTR) (s), MAX_APP_LEN, UDOSH_INI);
	if (strcmp(s, "Deutsch")==0)	guilang= GUIGER;
	if (strcmp(s, "English")==0)	guilang= GUIENG;


	GetPrivateProfileString("Shell", "Logfile",  "", (LPSTR) (s), MAX_APP_LEN, UDOSH_INI);
	if (stricmp(s, S_TRUE)==0)		use_log= TRUE;

	GetPrivateProfileString("Shell", "Hypfile",  "", (LPSTR) (s), MAX_APP_LEN, UDOSH_INI);
	if (stricmp(s, S_TRUE)==0)		use_hyp= TRUE;

	GetPrivateProfileString("Shell", "Treefile",  "", (LPSTR) (s), MAX_APP_LEN, UDOSH_INI);
	if (stricmp(s, S_TRUE)==0)		use_tree= TRUE;

	GetPrivateProfileString("Shell", "Testmode",  "", (LPSTR) (s), MAX_APP_LEN, UDOSH_INI);
	if (stricmp(s, S_TRUE)==0)		mode_test= TRUE;

	GetPrivateProfileString("Shell", "Verbose",  "", (LPSTR) (s), MAX_APP_LEN, UDOSH_INI);
	if (stricmp(s, S_TRUE)==0)		mode_verb= TRUE;


	GetPrivateProfileString("Shell", "Folder",  "", (LPSTR) (s), MAX_APP_LEN, UDOSH_INI);
	if (stricmp(s, S_TRUE)==0)		mode_folder= TRUE;

	GetPrivateProfileString("Shell", "OptionD",  "", (LPSTR) (s), MAX_APP_LEN, UDOSH_INI);
	if (stricmp(s, S_TRUE)==0)		use_symbol1= TRUE;

	GetPrivateProfileString("Shell", "OptionD2",  "", (LPSTR) (s), MAX_APP_LEN, UDOSH_INI);
	if (stricmp(s, S_TRUE)==0)		use_symbol2= TRUE;

	GetPrivateProfileString("Shell", "OptionD3",  "", (LPSTR) (s), MAX_APP_LEN, UDOSH_INI);
	if (stricmp(s, S_TRUE)==0)		use_symbol3= TRUE;

	GetPrivateProfileString("Shell", "Symbol",  "", (LPSTR) (symbol), MAX_FILE_LEN, UDOSH_INI);
	GetPrivateProfileString("Shell", "Symbol2",  "", (LPSTR) (symbol2), MAX_FILE_LEN, UDOSH_INI);
	GetPrivateProfileString("Shell", "Symbol3",  "", (LPSTR) (symbol3), MAX_FILE_LEN, UDOSH_INI);

}	/* read_settings */


void write_settings ( void )
{
	char s[128];

#if 1
	WritePrivateProfileString("Shell", "Source",  (LPSTR) (fsource), UDOSH_INI);
	WritePrivateProfileString("Shell", "Dest",  (LPSTR) (fdest), UDOSH_INI);
#endif

	if (guilang==GUIGER)
		WritePrivateProfileString("Shell", "Language",  "Deutsch", UDOSH_INI);
    else
		WritePrivateProfileString("Shell", "Language",  "English", UDOSH_INI);


	switch (destformat)
	{
		case ID_DMAIN_ASC:	strcpy(s, S_ASC);	break;
		case ID_DMAIN_AQV:	strcpy(s, S_AQV);	break;
		case ID_DMAIN_HTM:	strcpy(s, S_HTM);	break;
		case ID_DMAIN_HPH:	strcpy(s, S_HPH);	break;
		case ID_DMAIN_TEX:	strcpy(s, S_TEX);	break;
		case ID_DMAIN_LDS:	strcpy(s, S_LDS);	break;
		case ID_DMAIN_MAN:	strcpy(s, S_MAN);	break;
		case ID_DMAIN_NRO:	strcpy(s, S_NRO);	break;
		case ID_DMAIN_PCH:	strcpy(s, S_PCH);	break;
		case ID_DMAIN_RTF:	strcpy(s, S_RTF);	break;
		case ID_DMAIN_STG:	strcpy(s, S_STG);	break;
		case ID_DMAIN_INF:	strcpy(s, S_INF);	break;
		case ID_DMAIN_TVH:	strcpy(s, S_TVH);	break;
		case ID_DMAIN_WIN:	strcpy(s, S_WIN);	break;
		case ID_DMAIN_LYX:	strcpy(s, S_LYX);	break;
		case ID_DMAIN_SRC:	strcpy(s, S_SRC);	break;
		case ID_DMAIN_SRP:	strcpy(s, S_SRP);	break;
	}
	
	WritePrivateProfileString("Shell", "Format",  (LPSTR) (s), UDOSH_INI);

	WritePrivateProfileString("Shell", "Logfile", (LPSTR) (use_log ? S_TRUE : S_FALSE), UDOSH_INI);
	WritePrivateProfileString("Shell", "Hypfile", (LPSTR) (use_hyp ? S_TRUE : S_FALSE), UDOSH_INI);
	WritePrivateProfileString("Shell", "Treefile", (LPSTR) (use_tree ? S_TRUE : S_FALSE), UDOSH_INI);
	WritePrivateProfileString("Shell", "Testmode", (LPSTR) (mode_test ? S_TRUE : S_FALSE), UDOSH_INI);
	WritePrivateProfileString("Shell", "Folder", (LPSTR) (mode_folder ? S_TRUE : S_FALSE), UDOSH_INI);
	WritePrivateProfileString("Shell", "Verbose", (LPSTR) (mode_verb ? S_TRUE : S_FALSE), UDOSH_INI);
	WritePrivateProfileString("Shell", "OptionD", (LPSTR) (use_symbol1 ? S_TRUE : S_FALSE), UDOSH_INI);
	WritePrivateProfileString("Shell", "OptionD2", (LPSTR) (use_symbol2 ? S_TRUE : S_FALSE), UDOSH_INI);
	WritePrivateProfileString("Shell", "OptionD3", (LPSTR) (use_symbol3 ? S_TRUE : S_FALSE), UDOSH_INI);
	WritePrivateProfileString("Shell", "Symbol", (LPSTR) symbol, UDOSH_INI);
	WritePrivateProfileString("Shell", "Symbol2", (LPSTR) symbol2, UDOSH_INI);
	WritePrivateProfileString("Shell", "Symbol3", (LPSTR) symbol3, UDOSH_INI);

}	/* write_settings */


void read_ini_form (char *key, FORMCONFIG *cfg)
{
	GetPrivateProfileString(key, DEST_APP,  "", (LPSTR) (cfg->app_dest), MAX_APP_LEN, UDOSH_INI);
	GetPrivateProfileString(key, DEST_OPT,  "", (LPSTR) (cfg->opt_dest), MAX_APP_LEN, UDOSH_INI);
	GetPrivateProfileString(key, DEST_EDIT,  "", (LPSTR) (cfg->edi_dest), MAX_APP_LEN, UDOSH_INI);
	GetPrivateProfileString(key, DEST_UNIX,  "", (LPSTR) (cfg->unix_dest), MAX_UNIX_LEN, UDOSH_INI);
	GetPrivateProfileString(key, DEST_LOWER,  "", (LPSTR) (cfg->lower_dest), MAX_LOWER_LEN, UDOSH_INI);

	GetPrivateProfileString(key, PARAM_APP, "", (LPSTR) (cfg->app_param), MAX_APP_LEN, UDOSH_INI);
	GetPrivateProfileString(key, PARAM_OPT, "", (LPSTR) (cfg->opt_param), MAX_APP_LEN, UDOSH_INI);
	GetPrivateProfileString(key, PARAM_SUF, "", (LPSTR) (cfg->suf_param), MAX_SUF_LEN, UDOSH_INI);
	GetPrivateProfileString(key, PARAM_EDIT, "", (LPSTR) (cfg->edi_param), MAX_APP_LEN, UDOSH_INI);
	GetPrivateProfileString(key, PARAM_UNIX,  "", (LPSTR) (cfg->unix_param), MAX_UNIX_LEN, UDOSH_INI);
	GetPrivateProfileString(key, PARAM_LOWER,  "", (LPSTR) (cfg->lower_param), MAX_LOWER_LEN, UDOSH_INI);

	GetPrivateProfileString(key, FINAL_APP, "", (LPSTR) (cfg->app_final), MAX_APP_LEN, UDOSH_INI);
	GetPrivateProfileString(key, FINAL_OPT, "", (LPSTR) (cfg->opt_final), MAX_APP_LEN, UDOSH_INI);
	GetPrivateProfileString(key, FINAL_SUF, "", (LPSTR) (cfg->suf_final), MAX_SUF_LEN, UDOSH_INI);
	GetPrivateProfileString(key, FINAL_EDIT, "", (LPSTR) (cfg->edi_final), MAX_APP_LEN, UDOSH_INI);
	GetPrivateProfileString(key, FINAL_UNIX,  "", (LPSTR) (cfg->unix_final), MAX_UNIX_LEN, UDOSH_INI);
	GetPrivateProfileString(key, FINAL_LOWER,  "", (LPSTR) (cfg->lower_final), MAX_LOWER_LEN, UDOSH_INI);

}	/* read_ini_form */


void read_ini ( void )
{

	GetPrivateProfileString("UDO",	  "App", "", (LPSTR) &(config.udo), MAX_APP_LEN, UDOSH_INI);
	GetPrivateProfileString("UDO",	  "Opt", "", (LPSTR) &(config.opt), MAX_APP_LEN, UDOSH_INI);
	GetPrivateProfileString("Editor", "App", "", (LPSTR) &(config.edi), MAX_APP_LEN, UDOSH_INI);

	read_ini_form((LPSTR) S_ASC,	&(config.asc));
	read_ini_form((LPSTR) S_AQV,	&(config.aqv));
	read_ini_form((LPSTR) S_HTM,	&(config.htm));
	read_ini_form((LPSTR) S_HPH,	&(config.hph));
	read_ini_form((LPSTR) S_TEX,	&(config.tex));
	read_ini_form((LPSTR) S_LDS,	&(config.lds));
	read_ini_form((LPSTR) S_MAN,	&(config.man));
	read_ini_form((LPSTR) S_NRO,	&(config.nro));
	read_ini_form((LPSTR) S_PCH,	&(config.pch));
	read_ini_form((LPSTR) S_RTF,	&(config.rtf));
	read_ini_form((LPSTR) S_STG,	&(config.stg));
	read_ini_form((LPSTR) S_INF,	&(config.inf));
	read_ini_form((LPSTR) S_TVH,	&(config.tvh));
	read_ini_form((LPSTR) S_WIN,	&(config.win));
	read_ini_form((LPSTR) S_LYX,	&(config.lyx));
	read_ini_form((LPSTR) S_SRC,	&(config.src));
	read_ini_form((LPSTR) S_SRP,	&(config.srp));

	// Neu: 0.06: Defaulteinstellungen setzen, falls keine Optionen geladen wurden

	// HTML

	if ( config.htm.suf_final[0]=='\0' )	strcpy(config.htm.suf_final, ".htm");

	// LaTeX
    
	if ( config.tex.suf_param[0]=='\0' )	strcpy(config.tex.suf_param, ".idx");
	if ( config.tex.suf_final[0]=='\0' )	strcpy(config.tex.suf_final, ".dvi");

	// Texinfo

	if ( config.inf.suf_param[0]=='\0' )	strcpy(config.inf.suf_param, ".inf");

	// WinHelp

	if ( config.win.suf_param[0]=='\0' )	strcpy(config.win.suf_param, ".hpj");
	if ( config.win.suf_final[0]=='\0' )	strcpy(config.win.suf_final, ".hlp");
	if ( config.win.app_final[0]=='\0' )	strcpy(config.win.app_final, "winhelp.exe");


	// Turbo-Vision-Help

	if ( config.tvh.suf_final[0]=='\0' )	strcpy(config.tvh.suf_final, ".hlp");

	// Pure-C-Help

	if ( config.pch.suf_param[0]=='\0' )	strcpy(config.pch.suf_param, ".cmd");

	// QuickView

	if ( config.aqv.suf_param[0]=='\0' )	strcpy(config.aqv.suf_param, ".hpj");
	if ( config.aqv.suf_final[0]=='\0' )	strcpy(config.aqv.suf_final, ".hlp");


}	/* read_ini */



void write_ini_form (char *key, FORMCONFIG *cfg)
{
	if (cfg->formconfig_changed==FALSE)
	{	return;
	}

	if ( cfg->app_dest[0]!='\0')	WritePrivateProfileString(key, DEST_APP,   (LPSTR) (cfg->app_dest), UDOSH_INI);
	if ( cfg->opt_dest[0]!='\0')	WritePrivateProfileString(key, DEST_OPT,   (LPSTR) (cfg->opt_dest), UDOSH_INI);
	if ( cfg->edi_dest[0]!='\0')	WritePrivateProfileString(key, DEST_EDIT,  (LPSTR) (cfg->edi_dest), UDOSH_INI);
	if ( cfg->unix_dest[0]!='\0')	WritePrivateProfileString(key, DEST_UNIX,  (LPSTR) (cfg->unix_dest), UDOSH_INI);
	if ( cfg->lower_dest[0]!='\0')	WritePrivateProfileString(key, DEST_LOWER, (LPSTR) (cfg->lower_dest), UDOSH_INI);

	if ( cfg->app_param[0]!='\0')	WritePrivateProfileString(key, PARAM_APP,   (LPSTR) (cfg->app_param), UDOSH_INI);
	if ( cfg->opt_param[0]!='\0')	WritePrivateProfileString(key, PARAM_OPT,   (LPSTR) (cfg->opt_param), UDOSH_INI);
	if ( cfg->suf_param[0]!='\0')	WritePrivateProfileString(key, PARAM_SUF,   (LPSTR) (cfg->suf_param), UDOSH_INI);
	if ( cfg->edi_param[0]!='\0')	WritePrivateProfileString(key, PARAM_EDIT,  (LPSTR) (cfg->edi_param), UDOSH_INI);
	if ( cfg->unix_param[0]!='\0')	WritePrivateProfileString(key, PARAM_UNIX,  (LPSTR) (cfg->unix_param), UDOSH_INI);
	if ( cfg->lower_param[0]!='\0')	WritePrivateProfileString(key, PARAM_LOWER, (LPSTR) (cfg->lower_param), UDOSH_INI);

	if ( cfg->app_final[0]!='\0')	WritePrivateProfileString(key, FINAL_APP,   (LPSTR) (cfg->app_final), UDOSH_INI);
	if ( cfg->opt_final[0]!='\0')	WritePrivateProfileString(key, FINAL_OPT,   (LPSTR) (cfg->opt_final), UDOSH_INI);
	if ( cfg->suf_final[0]!='\0')	WritePrivateProfileString(key, FINAL_SUF,   (LPSTR) (cfg->suf_final), UDOSH_INI);
	if ( cfg->edi_final[0]!='\0')	WritePrivateProfileString(key, FINAL_EDIT,  (LPSTR) (cfg->edi_final), UDOSH_INI);
	if ( cfg->unix_final[0]!='\0')	WritePrivateProfileString(key, FINAL_UNIX,  (LPSTR) (cfg->unix_final), UDOSH_INI);
	if ( cfg->lower_final[0]!='\0')	WritePrivateProfileString(key, FINAL_LOWER, (LPSTR) (cfg->lower_final), UDOSH_INI);

    cfg->formconfig_changed= FALSE;
}	/* write_ini_form */


void write_ini ( void )
{

	if (config.config_changed)
	{	WritePrivateProfileString("UDO",	"App",	(LPSTR) &(config.udo), UDOSH_INI);
		WritePrivateProfileString("UDO",	"Opt",	(LPSTR) &(config.opt), UDOSH_INI);
		WritePrivateProfileString("Editor",	"App",	(LPSTR) &(config.edi), UDOSH_INI);
	}

	write_ini_form((LPSTR) S_ASC,	&(config.asc));
	write_ini_form((LPSTR) S_AQV,	&(config.aqv));
	write_ini_form((LPSTR) S_HTM,	&(config.htm));
	write_ini_form((LPSTR) S_HPH,	&(config.hph));
	write_ini_form((LPSTR) S_TEX,	&(config.tex));
	write_ini_form((LPSTR) S_LDS,	&(config.lds));
	write_ini_form((LPSTR) S_MAN,	&(config.man));
	write_ini_form((LPSTR) S_NRO,	&(config.nro));
	write_ini_form((LPSTR) S_PCH,	&(config.pch));
	write_ini_form((LPSTR) S_RTF,	&(config.rtf));
	write_ini_form((LPSTR) S_STG,	&(config.stg));
	write_ini_form((LPSTR) S_INF,	&(config.inf));
	write_ini_form((LPSTR) S_TVH,	&(config.tvh));
	write_ini_form((LPSTR) S_WIN,	&(config.win));
	write_ini_form((LPSTR) S_LYX,	&(config.lyx));
	write_ini_form((LPSTR) S_SRC,	&(config.src));
	write_ini_form((LPSTR) S_SRP,	&(config.srp));

}	/* write_ini */



void get_form_config ( int f, FORMCONFIG *cfg )
{
	switch (f)
	{
		case ID_DMAIN_ASC:	memcpy(cfg, &(config.asc), sizeof(FORMCONFIG));	break;
		case ID_DMAIN_AQV:	memcpy(cfg, &(config.aqv), sizeof(FORMCONFIG));	break;
		case ID_DMAIN_HTM:	memcpy(cfg, &(config.htm), sizeof(FORMCONFIG));	break;
		case ID_DMAIN_HPH:	memcpy(cfg, &(config.hph), sizeof(FORMCONFIG));	break;
		case ID_DMAIN_TEX:	memcpy(cfg, &(config.tex), sizeof(FORMCONFIG));	break;
		case ID_DMAIN_LDS:	memcpy(cfg, &(config.lds), sizeof(FORMCONFIG));	break;
		case ID_DMAIN_MAN:	memcpy(cfg, &(config.man), sizeof(FORMCONFIG));	break;
		case ID_DMAIN_NRO:	memcpy(cfg, &(config.nro), sizeof(FORMCONFIG));	break;
		case ID_DMAIN_PCH:	memcpy(cfg, &(config.pch), sizeof(FORMCONFIG));	break;
		case ID_DMAIN_RTF:	memcpy(cfg, &(config.rtf), sizeof(FORMCONFIG));	break;
		case ID_DMAIN_STG:	memcpy(cfg, &(config.stg), sizeof(FORMCONFIG));	break;
		case ID_DMAIN_TVH:	memcpy(cfg, &(config.tvh), sizeof(FORMCONFIG));	break;
		case ID_DMAIN_INF:	memcpy(cfg, &(config.inf), sizeof(FORMCONFIG));	break;
		case ID_DMAIN_WIN:	memcpy(cfg, &(config.win), sizeof(FORMCONFIG));	break;
		case ID_DMAIN_LYX:	memcpy(cfg, &(config.lyx), sizeof(FORMCONFIG));	break;
		case ID_DMAIN_SRC:	memcpy(cfg, &(config.src), sizeof(FORMCONFIG));	break;
		case ID_DMAIN_SRP:	memcpy(cfg, &(config.srp), sizeof(FORMCONFIG));	break;
	}
}	/* get_form_config */


void set_form_config ( int f, FORMCONFIG *cfg )
{
	switch (f)
	{
		case ID_DMAIN_ASC:	memcpy(&(config.asc), cfg, sizeof(FORMCONFIG));	break;
		case ID_DMAIN_AQV:	memcpy(&(config.aqv), cfg, sizeof(FORMCONFIG));	break;
		case ID_DMAIN_HTM:	memcpy(&(config.htm), cfg, sizeof(FORMCONFIG));	break;
		case ID_DMAIN_HPH:	memcpy(&(config.hph), cfg, sizeof(FORMCONFIG));	break;
		case ID_DMAIN_TEX:	memcpy(&(config.tex), cfg, sizeof(FORMCONFIG));	break;
		case ID_DMAIN_LDS:	memcpy(&(config.lds), cfg, sizeof(FORMCONFIG));	break;
		case ID_DMAIN_MAN:	memcpy(&(config.man), cfg, sizeof(FORMCONFIG));	break;
		case ID_DMAIN_NRO:	memcpy(&(config.nro), cfg, sizeof(FORMCONFIG));	break;
		case ID_DMAIN_PCH:	memcpy(&(config.pch), cfg, sizeof(FORMCONFIG));	break;
		case ID_DMAIN_RTF:	memcpy(&(config.rtf), cfg, sizeof(FORMCONFIG));	break;
		case ID_DMAIN_STG:	memcpy(&(config.stg), cfg, sizeof(FORMCONFIG));	break;
		case ID_DMAIN_TVH:	memcpy(&(config.tvh), cfg, sizeof(FORMCONFIG));	break;
		case ID_DMAIN_INF:	memcpy(&(config.inf), cfg, sizeof(FORMCONFIG));	break;
		case ID_DMAIN_WIN:	memcpy(&(config.win), cfg, sizeof(FORMCONFIG));	break;
		case ID_DMAIN_LYX:	memcpy(&(config.lyx), cfg, sizeof(FORMCONFIG));	break;
		case ID_DMAIN_SRC:	memcpy(&(config.src), cfg, sizeof(FORMCONFIG));	break;
		case ID_DMAIN_SRP:	memcpy(&(config.srp), cfg, sizeof(FORMCONFIG));	break;
	}
}	/* set_form_config */


/*	############################################################
	#
	# Fehlermeldungen
	#
	############################################################	*/

/*	------------------------------------------------------------
	Fehlermeldung ausgeben, Ausrufungsicon, nur OK-Button
	------------------------------------------------------------	*/
void alert_warning ( HWND hWnd, char *s )
{
	/*BWCC*/MessageBox(hWnd, s, "UDO Shell", MB_OK | MB_ICONEXCLAMATION);
}

/*	------------------------------------------------------------
	Diverse Fehlermeldung ausgeben
	------------------------------------------------------------	*/
void alert_source_missing ( HWND hWnd )
{
	alert_warning(hWnd, (guilang==GUIGER) ? "Keine Quelldatei angegeben!" : "Source file is missing!");
}

void alert_dest_missing ( HWND hWnd )
{
	alert_warning(hWnd, (guilang==GUIGER) ? "Keine Zieldatei angegeben!" : "Destination file is missing!");
}

void alert_file_missing ( HWND hWnd, char *f )
{
	char m[512];

	if (guilang==GUIGER)
	sprintf(m, (guilang==GUIGER) ? "Diese Datei existiert nicht:\n%s"
    							 : "This file doesn't exist:\n%s", f);

	alert_warning(hWnd, m);
}


/*	------------------------------------------------------------
	Frage stellen, Ja/Nein
	------------------------------------------------------------	*/
int alert_yesno ( HWND hWnd, char *s )
{	return ( MessageBox(hWnd, s, "UDO Shell", MB_YESNO | MB_ICONQUESTION) );
}

/*	------------------------------------------------------------
	Programm starten und gff. Fehlermeldung ausgeben
	------------------------------------------------------------	*/
void MyWinExec (HWND hWnd, char *exe, char *opt)
{
	char	cmd[256], s[256], msg[256];
	int		ret;

	sprintf(cmd, "%s %s", exe, opt);
	ret= WinExec(cmd, SW_SHOW);

	if (ret<32)
	{
		switch (ret)
		{	case 0:		strcpy(s, "Zuwenig freier Speicher.");										break;
			case 2:		strcpy(s, "Datei nicht gefunden.");											break;
			case 3:		strcpy(s, "Pfad nicht gefunden.");											break;
			case 5:		strcpy(s, "Versuch, eine Task dynamisch zu beenden.");						break;
			case 6:		strcpy(s, "Bibliothek erfordert getrennte Datensegmente fr jede Task.");	break;

			case 10:	strcpy(s, "Falsche Windows-Version.");	break;
			case 11:	strcpy(s, "Ungltige .EXE-Datei.");		break;
			case 12:	strcpy(s, "OS/2-Anwendung.");			break;
			case 13:	strcpy(s, "DOS 4.0-Anwendung.");		break;
			case 14:	strcpy(s, "Unbekannter .EXE-Typ");		break;
			default:	strcpy(s, "");
		}

        if (guilang==GUIGER)
			sprintf(msg, "Fehler #%d ist beim\nAufruf von WinExec() aufgetreten\n%s", ret, s);
        else
			sprintf(msg, "Error #%d appeared\nwhen calling WinExec():\n%s", ret, s);

		/*BWCC*/MessageBox(hWnd, msg, "UDO Shell", MB_OK);
	}

}	/* MyWinExec */



/*	------------------------------------------------------------
	Ins Verzeichnis der Quelldatei wechseln
	------------------------------------------------------------	*/
void chdir_file ( char *f )
{
	char d[256], p[256], n[256], s[256], ch[256];

	fsplit(f, d, p, n, s);
	sprintf(ch, "%s%s", d, p);

	if (ch[0]!='\0')
	{	chdir(ch);
	}

}	/* chdir_file */



/*	############################################################
	#
	# Programme starten
	#
	############################################################	*/

/*	------------------------------------------------------------
	\ in / wandeln
	------------------------------------------------------------	*/
void backslash2slash ( char *s )
{
	size_t i;
	
	for (i=0; i<strlen(s); i++)
	{	if (s[i]=='\\')	s[i]='/';
	}
}


/*	------------------------------------------------------------
	Testen, ob die Datei existiert
	------------------------------------------------------------	*/
int file_exists ( char *s )
{
	FILE *file;
	
	file= fopen(s, "r");
	
	if (!file)
	{	return(0);
	}
	
	fclose(file);
	return(1);
}	/* file_exists */


/*	------------------------------------------------------------
	Testen, ob ein Profile-String "TRUE" lautet
	------------------------------------------------------------	*/
int is_true (char *s)
{	return (stricmp(s, S_TRUE)==0);
}


/*	------------------------------------------------------------
	Datei an Editor bergeben
	------------------------------------------------------------	*/
void exec_editor ( HWND hWnd, char *s )
{

	char prg[256];

	if (config.edi[0]=='\0')
	{	if ( select_editor(hWnd, config.edi, "Select editor for UDO files") )
		{	config.config_changed= TRUE;
        	adjust_buttons(hWnd);
		}
		else
		{	return;
        }
    }

	if (!file_exists(s))
		alert_file_missing(hWnd, s);
	else
		MyWinExec(hWnd, config.edi, s);
}	/* exec_editor */


/*	------------------------------------------------------------
	UDO starten
	------------------------------------------------------------	*/
void exec_udo ( HWND hWnd, char *opt, char *f )
{
	char cmd[256];
	char prg[256];
	char title[256];

	if (config.udo[0]=='\0')
	{
		(guilang==GUIGER) ? strcpy(title, "Auswhlen von UDO386.EXE")
						  : strcpy(title, "Select UDO386.EXE");    	

		if ( select_program(hWnd, title, prg) )
		{	strcpy(config.udo, prg);
        	config.config_changed= TRUE;
		}
		else
		{	return;
        }
    }

	if (!file_exists(f))
		alert_file_missing(hWnd, f);
	else
	{	sprintf(cmd, "%s %s %s", config.opt, opt, f);
		MyWinExec(hWnd, config.udo, cmd);
	}

}	/* exec_udo */



/*	------------------------------------------------------------
	Programm fr Zieldatei starten
	------------------------------------------------------------	*/
void exec_dest ( HWND hWnd, char *s )
{
	FORMCONFIG	fc;
	char cmd[256], prg[256], title[256];
	char filename[256];

	strcpy(filename, s);

	get_form_config(destformat, &fc);

	if (fc.app_dest[0]=='\0')
	{
		(guilang==GUIGER) ? strcpy(title, "Programm fr die Zieldatei auswhlen")
						  : strcpy(title, "Select program for destiantion file");

		if ( select_program(hWnd, title, prg) )
		{   strcpy(fc.app_dest, prg);
        	fc.formconfig_changed= TRUE;
			set_form_config(destformat, &fc);
            adjust_buttons(hWnd);
		}
        else
		{	return;
        }
    }

	if (!file_exists(s))
	{	alert_file_missing(hWnd, s);
	}
	else
	{
		chdir_file(filename);

		if ( is_true(fc.unix_dest) )
		{	backslash2slash(filename);
		}

		sprintf(cmd, "%s %s", fc.opt_dest, filename);

		MyWinExec(hWnd, fc.app_dest, cmd);
	}
}	/* exec_dest */


/*	------------------------------------------------------------
	Programm fr Zieldatei starten
	------------------------------------------------------------	*/
void exec_dest_edi ( HWND hWnd, char *s )
{
	FORMCONFIG	fc;
	char prg[256], title[256];

	get_form_config(destformat, &fc);

	if (fc.edi_dest[0]=='\0')
	{
		(guilang==GUIGER) ? strcpy(title, "Editor fr die Zieldatei auswhlen")
						  : strcpy(title, "Select editor for destiantion file");

		if ( select_editor(hWnd, fc.edi_dest, title) )
		{	fc.formconfig_changed= TRUE;
			set_form_config(destformat, &fc);
			adjust_buttons(hWnd);
		}
		else
		{	return;
		}
	}

	if (!file_exists(s))
		alert_file_missing(hWnd, s);
	else
	{
    	chdir_file(s);
		MyWinExec(hWnd, fc.edi_dest, s);
	}

}	/* exec_dest_edi */


/*	------------------------------------------------------------
	Programm fr Zielparameter starten
	------------------------------------------------------------	*/
void exec_param ( HWND hWnd, char *s )
{
	FORMCONFIG	fc;
	char	filename[256];
	char prg[256], title[256];

	strcpy(filename, s);

	get_form_config(destformat, &fc);

	if (fc.app_param[0]=='\0')
	{

		(guilang==GUIGER) ? strcpy(title, "Programm fr die Parameterdatei auswhlen")
						  : strcpy(title, "Select program for parameter file");

		if ( select_program(hWnd, title, prg) )
		{	strcpy(fc.app_param, prg);
			fc.formconfig_changed= TRUE;
			set_form_config(destformat, &fc);
			adjust_buttons(hWnd);
		}
        else
		{	return;
        }
    }

	if (!file_exists(s))
		alert_file_missing(hWnd, s);
	else
	{
		chdir_file(filename);

		if ( is_true(fc.unix_param) )
		{	backslash2slash(filename);
		}
		
		MyWinExec(hWnd, fc.app_param, filename);
	}
}	/* exec_param */


/*	------------------------------------------------------------
	Programm fr Zielparameter starten
	------------------------------------------------------------	*/
void exec_param_edi ( HWND hWnd, char *s )
{
	FORMCONFIG	fc;
	char prg[256], title[256];

	get_form_config(destformat, &fc);

	if (fc.edi_param[0]=='\0')
	{
		(guilang==GUIGER) ? strcpy(title, "Editor fr die Parameterdatei auswhlen")
						  : strcpy(title, "Select editor for parameter file");

		if ( select_editor(hWnd, fc.edi_param, "Select editor for parameter file") )
		{	fc.formconfig_changed= TRUE;
			set_form_config(destformat, &fc);
			adjust_buttons(hWnd);
		}
		else
		{	return;
        }
    }

	if (!file_exists(s))
		alert_file_missing(hWnd, s);
	else
		MyWinExec(hWnd, fc.edi_param, s);

}	/* exec_param_edi */


/*	------------------------------------------------------------
	Programm fr Ergebnisdatei (.dvi, .hlp) starten
	------------------------------------------------------------	*/
void exec_result ( HWND hWnd, char *s )
{
	FORMCONFIG	fc;
	char	filename[256];
	char prg[256], title[256];

	strcpy(filename, s);

	get_form_config(destformat, &fc);

	if (fc.app_final[0]=='\0')
	{
		(guilang==GUIGER) ? strcpy(title, "Programm fr die Zieldatei auswhlen")
						  : strcpy(title, "Select program for final file");

		if ( select_program(hWnd, title, prg) )
		{	strcpy(fc.app_final, prg);
			fc.formconfig_changed= TRUE;
			set_form_config(destformat, &fc);
			adjust_buttons(hWnd);
		}
        else
		{	return;
        }
    }


	if (!file_exists(s))
		alert_file_missing(hWnd, s);
	else
	{
		chdir_file(filename);

		if ( is_true(fc.unix_final) )
		{	backslash2slash(filename);
		}

		MyWinExec(hWnd, fc.app_final, filename);
	}
}	/* exec_result */


/*	------------------------------------------------------------
	Editor fr Ergebnisdatei (.dvi, .hlp) starten
	------------------------------------------------------------	*/
void exec_result_edi ( HWND hWnd, char *s )
{
	FORMCONFIG	fc;
    char prg[256], title[256];

	get_form_config(destformat, &fc);

	if (fc.edi_final[0]=='\0')
	{
		(guilang==GUIGER) ? strcpy(title, "Editor fr die Zieldatei auswhlen")
						  : strcpy(title, "Select editor for final file");

		if ( select_editor(hWnd, fc.edi_final, title) )
		{	fc.formconfig_changed= TRUE;
			set_form_config(destformat, &fc);
			adjust_buttons(hWnd);
		}
		else
		{	return;
        }
    }


	if (!file_exists(s))
		alert_file_missing(hWnd, s);
	else
		MyWinExec(hWnd, fc.edi_final, s);

}	/* exec_result_edi */


/*	############################################################
	#
	# Dateinamen anpassen
	#
	############################################################	*/

/*	------------------------------------------------------------
	Parameterdatei der Zieldatei anpassen
	------------------------------------------------------------	*/
void adjust_param ( HWND hWnd )
{
	FORMCONFIG fc;
	char driv[32], path[128], file[128], suff[32];

	fparam[0]= '\0';

	if ( fdest[0]!='\0' )
	{	get_form_config(destformat, &fc);

		if (fc.suf_param[0]!='\0')
		{	fsplit(fdest, driv, path, file, suff);
			sprintf(fparam, "%s%s%s%s", driv, path, file, fc.suf_param);
		}
	}

	SetDlgItemText(hWnd, ID_DMAIN_PARAM, fparam);

}	/* adjust_param */


/*	------------------------------------------------------------
	Parameterdatei der fertigen Datei anpassen
	------------------------------------------------------------	*/
void adjust_result ( HWND hWnd )
{
	FORMCONFIG fc;
	char driv[32], path[128], file[128], suff[32];

	fresult[0]= '\0';

	if ( fdest[0]!='\0' )
	{
		get_form_config(destformat, &fc);

		if (fc.suf_final[0]!='\0')
		{	fsplit(fdest, driv, path, file, suff);
			sprintf(fresult, "%s%s%s%s", driv, path, file, fc.suf_final);
		}
	}

	SetDlgItemText(hWnd, ID_DMAIN_RESUL, fresult);

}	/* adjust_result */


/*	------------------------------------------------------------
	Buttons anpassen
	------------------------------------------------------------	*/
void adjust_buttons ( HWND hWnd )
{
	FORMCONFIG fc;
	char driv[32], path[128], file[128], suff[32];
	char bt[32];

	fsplit(config.udo, driv, path, file, suff);
	sprintf(bt, "%s%s", file, suff);
	SetDlgItemText(hWnd, ID_DMAIN_SEXEC, file /*bt*/);

	fsplit(config.edi, driv, path, file, suff);
	sprintf(bt, "%s%s", file, suff);
	SetDlgItemText(hWnd, ID_DMAIN_SEDIT, file /*bt*/);

	get_form_config(destformat, &fc);

	fsplit(fc.app_dest, driv, path, file, suff);
	sprintf(bt, "%s%s", file, suff);
	SetDlgItemText(hWnd, ID_DMAIN_DEXEC, file /*bt*/);

	fsplit(fc.edi_dest, driv, path, file, suff);
	sprintf(bt, "%s%s", file, suff);
	SetDlgItemText(hWnd, ID_DMAIN_DEDIT, file /*bt*/);

	fsplit(fc.app_param, driv, path, file, suff);
	sprintf(bt, "%s%s", file, suff);
	SetDlgItemText(hWnd, ID_DMAIN_PEXEC, file /*bt*/);

	fsplit(fc.edi_param, driv, path, file, suff);
	sprintf(bt, "%s%s", file, suff);
	SetDlgItemText(hWnd, ID_DMAIN_PEDIT, file /*bt*/);

	fsplit(fc.app_final, driv, path, file, suff);
	sprintf(bt, "%s%s", file, suff);
	SetDlgItemText(hWnd, ID_DMAIN_REXEC, file /*bt*/);

	fsplit(fc.edi_final, driv, path, file, suff);
	sprintf(bt, "%s%s", file, suff);
	SetDlgItemText(hWnd, ID_DMAIN_REDIT, file /*bt*/);

}	/* adjust_buttons */


/*	------------------------------------------------------------
	Zieldatei anpassen und Dialog erneuern
	------------------------------------------------------------	*/
void adjust_dest ( HWND hWnd )
{
	FORMCONFIG fc;
	char driv[32], path[128], file[128], suff[32];
	char logsuff[32], hypsuff[32], treesuff[32], folder[32];

	GetDlgItemText(hWnd, ID_DMAIN_SOUR, fsource, MAX_FILE_LEN);

	if ( fsource[0]=='\0' )
	{	fdest[0]= '\0';
		fhyp[0]= '\0';
		flog[0]= '\0';
		ftree[0]= '\0';
	}
	else
	{
		fsplit(fsource, driv, path, file, suff);

		get_form_config(destformat, &fc);

		if (is_true(fc.lower_dest))
		{	strlwr(file);
        }


		switch (destformat)
		{	case ID_DMAIN_ASC:	strcpy(suff, ".txt");	strcpy(logsuff, ".ula");	strcpy(folder, "ascii");	break;
			case ID_DMAIN_HTM:	strcpy(suff, ".htm");	strcpy(logsuff, ".ulh");	strcpy(folder, "html");		break;
			case ID_DMAIN_HPH:	strcpy(suff, ".sgm");	strcpy(logsuff, ".ulg");	strcpy(folder, "helptag");	break;
			case ID_DMAIN_TEX:	strcpy(suff, ".tex");	strcpy(logsuff, ".ult");	strcpy(folder, "latex");	break;
			case ID_DMAIN_LDS:	strcpy(suff, ".sgm");	strcpy(logsuff, ".ulx");	strcpy(folder, "linuxdoc");	break;
			case ID_DMAIN_MAN:	strcpy(suff, ".man");	strcpy(logsuff, ".ulm");	strcpy(folder, "man");		break;
			case ID_DMAIN_NRO:	strcpy(suff, ".1");		strcpy(logsuff, ".ul1");	strcpy(folder, "nroff");	break;
			case ID_DMAIN_PCH:	strcpy(suff, ".scr");	strcpy(logsuff, ".ulp");	strcpy(folder, "pchelp");	break;
			case ID_DMAIN_RTF:	strcpy(suff, ".rtf");	strcpy(logsuff, ".ulr");	strcpy(folder, "rtf");		break;
			case ID_DMAIN_STG:	strcpy(suff, ".stg");	strcpy(logsuff, ".uls");	strcpy(folder, "stguide");	break;
			case ID_DMAIN_INF:	strcpy(suff, ".tex");	strcpy(logsuff, ".uli");	strcpy(folder, "texinfo");	break;
			case ID_DMAIN_TVH:	strcpy(suff, ".txt");	strcpy(logsuff, ".ulv");	strcpy(folder, "tvhelp");	break;
			case ID_DMAIN_WIN:	strcpy(suff, ".rtf");	strcpy(logsuff, ".ulw");	strcpy(folder, "winhelp");	break;
			case ID_DMAIN_AQV:	strcpy(suff, ".rtf");	strcpy(logsuff, ".ulq");	strcpy(folder, "aqv");		break;
			case ID_DMAIN_LYX:	strcpy(suff, ".lyx");	strcpy(logsuff, ".ull");	strcpy(folder, "lyx");		break;
			case ID_DMAIN_SRC:	strcpy(suff, ".c");		strcpy(logsuff, ".ulc");	strcpy(folder, "c");		break;
			case ID_DMAIN_SRP:	strcpy(suff, ".pas");	strcpy(logsuff, ".ulp");	strcpy(folder, "pascal");	break;
		}

		if (mode_folder)
		{	strcat(path, folder);
        	strcat(path, "\\");
        }

		switch (destformat)
		{	case ID_DMAIN_ASC:
			case ID_DMAIN_MAN:
			case ID_DMAIN_STG:
			case ID_DMAIN_PCH:
				strcpy(hypsuff, logsuff);	hypsuff[2]='h';
				sprintf(fhyp, "%s%s%s%s", driv, path, file, hypsuff);
				break;
			default:
				fhyp[0]= '\0';
		}

		strcpy(treesuff, logsuff);	treesuff[2]='t';

		sprintf(fdest, "%s%s%s%s", driv, path, file, suff);
		sprintf(flog, "%s%s%s%s", driv, path, file, logsuff);
		sprintf(ftree, "%s%s%s%s", driv, path, file, treesuff);
	}

	SetDlgItemText(hWnd, ID_DMAIN_DEST, fdest);
	
	adjust_param(hWnd);
	adjust_result(hWnd);
	adjust_buttons(hWnd);
}	/* adjust_dest */


/*	------------------------------------------------------------
	Strings im Dialog auf eine andere Sprache einstellen
	------------------------------------------------------------	*/
void adjust_lang (HWND hWnd)
{
	if (guilang==GUIGER)
	{
		SetDlgItemText(hWnd, ID_DMAIN_SBOX, "UDO-Quelldatei:");
		SetDlgItemText(hWnd, ID_DMAIN_DBOX, "Zieldatei:");
		SetDlgItemText(hWnd, ID_DMAIN_PBOX, "Parameterdatei:");
		SetDlgItemText(hWnd, ID_DMAIN_RBOX, "Ergebnis:");

		SetDlgItemText(hWnd, ID_DMAIN_FBOX, "Format:" );
		SetDlgItemText(hWnd, ID_DMAIN_OBOX, "Optionen:" );

		SetDlgItemText(hWnd, ID_DMAIN_VERB, "Statusinfo" );
		SetDlgItemText(hWnd, ID_DMAIN_TEST, "Testmodus" );
		SetDlgItemText(hWnd, ID_DMAIN_FOLDER, "Verzeichnis" );

		SetDlgItemText(hWnd, ID_DMAIN_INFO, "Info" );
		SetDlgItemText(hWnd, ID_DMAIN_HELP, "Hilfe" );
		SetDlgItemText(hWnd, ID_DMAIN_LANG, "Sprache" );
		SetDlgItemText(hWnd, ID_DMAIN_EXIT, "Ende" );
	}
	else
    {
		SetDlgItemText(hWnd, ID_DMAIN_SBOX, "UDO source file:");
		SetDlgItemText(hWnd, ID_DMAIN_DBOX, "Destination file:");
		SetDlgItemText(hWnd, ID_DMAIN_PBOX, "Parameter file:");
		SetDlgItemText(hWnd, ID_DMAIN_RBOX, "Result:");

		SetDlgItemText(hWnd, ID_DMAIN_FBOX, "Format:" );
		SetDlgItemText(hWnd, ID_DMAIN_OBOX, "Options:" );

		SetDlgItemText(hWnd, ID_DMAIN_VERB, "Verbose" );
		SetDlgItemText(hWnd, ID_DMAIN_TEST, "Testmode" );
		SetDlgItemText(hWnd, ID_DMAIN_FOLDER, "Folder" );

		SetDlgItemText(hWnd, ID_DMAIN_INFO, "Info" );
		SetDlgItemText(hWnd, ID_DMAIN_HELP, "Help" );
		SetDlgItemText(hWnd, ID_DMAIN_LANG, "Language" );
		SetDlgItemText(hWnd, ID_DMAIN_EXIT, "Exit" );
	}

	UpdateWindow(hWnd);

}	/* adjust_lang */


/*	------------------------------------------------------------
	Optionen fuer die Kommandozeilenversion ermitteln
	------------------------------------------------------------	*/
void get_cli_option ( char *option )
{
	switch (destformat)
	{	case ID_DMAIN_HTM:	strcpy(option, "--html");		break;
		case ID_DMAIN_HPH:	strcpy(option, "--helptag");	break;
		case ID_DMAIN_TEX:	strcpy(option, "--tex");		break;
		case ID_DMAIN_LDS:	strcpy(option, "--linuxdoc");	break;
		case ID_DMAIN_MAN:	strcpy(option, "--man");		break;
		case ID_DMAIN_NRO:	strcpy(option, "--nroff");		break;
		case ID_DMAIN_PCH:	strcpy(option, "--pchelp");		break;
		case ID_DMAIN_RTF:	strcpy(option, "--rtf");		break;
		case ID_DMAIN_STG:	strcpy(option, "--stg");		break;
		case ID_DMAIN_INF:	strcpy(option, "--info");		break;
		case ID_DMAIN_TVH:	strcpy(option, "--vision");		break;
		case ID_DMAIN_WIN:	strcpy(option, "--win");		break;
		case ID_DMAIN_AQV:	strcpy(option, "--aqv");		break;
		case ID_DMAIN_LYX:	strcpy(option, "--lyx");		break;
		case ID_DMAIN_SRC:	strcpy(option, "--c");			break;
		case ID_DMAIN_SRP:	strcpy(option, "--pascal");		break;
		default:			strcpy(option, "--asc");		break;
	}
}


/*	------------------------------------------------------------
	Zielordner testen und notfalls erzeugen
	------------------------------------------------------------	*/
BOOL check_dest_path ( HWND hDlg, char *s )
{
	char dd[256], dp[256], dn[256], ds[256], p[256];
	char cwd[256];
	int mbRet, olddisk, newdisk;
    size_t dpsl;

	fsplit(s, dd, dp, dn, ds);
	sprintf(p, "%s%s", dd, dp);

	if (p[0]=='\0')
	{	return (TRUE);
	}

    olddisk= getdisk();
  	strcpy(cwd, "X:\\");     	/* fill string with form of response: X:\ */
  	cwd[0] = 'A' + olddisk;     /* replace X with current drive letter */
  	getcurdir(0, cwd+3);  		/* fill rest of string with current directory */


	// MessageBox(hDlg, cwd, "cwd", MB_ICONINFORMATION | MB_OK);

	if (chdir(p)==0)
	{	/* Ordner existiert */
		chdir(cwd);
        return (TRUE);
	}

    if (guilang==GUIGER)
	{	mbRet= MessageBox(hDlg,
				"Das Verzeichnis der Zieldatei existiert nicht.\n"
				"Damit UDO keinen Fehler meldet, mu es angelegt werden.\n"
           	 	"Soll das Verzeichnis jetzt angelegt werden?",
				"UDO Shell",
				MB_ICONQUESTION | MB_YESNO);
	}
	else
	{	mbRet= MessageBox(hDlg,
				"The destination folder doesn't exist.\n"
				"You have to create it to convert your source file.\n"
           	 	"Do you want to create the folder now?",
				"UDO Shell",
				MB_ICONQUESTION | MB_YESNO);
	}

    if (mbRet==IDNO)
	{	return(FALSE);
	}


	if (dd[0]!='\0')
	{   strupr(dd);
		newdisk= dd[0]-'A';
        if (olddisk!=newdisk)
		{	setdisk(newdisk);
			if (newdisk!=getdisk())
			{	MessageBox(hDlg,
					(guilang==GUIGER) ? "Konnte Laufwerk nicht setzen!" : "Couldn't set drive!",
					"UDO Shell",
					MB_ICONSTOP | MB_OK);
			}
        	setdisk(olddisk);
			return(FALSE);
        }
    }

	// MessageBox(hDlg, dp, "dp", MB_ICONINFORMATION | MB_OK);

    dpsl= strlen(dp);

	if (dp[dpsl-1]=='\\' || dp[dpsl-1]=='/')
	{	dp[dpsl-1]= '\0';
    }

	if (mkdir(dp)==0)
	{	/* Ordner wurde angelegt */
    	chdir(cwd);
    	return(TRUE);
	}

	MessageBox(hDlg,
		(guilang==GUIGER) ? "Verzeichnis konnte nicht angelegt werden!"
        				  : "Couldn't make directory!",
		"UDO Shell",
		MB_ICONSTOP | MB_OK);

    return (FALSE);

}	/* check_dest_path */








//*******************************************************************
// HandleMainDialog - handle Main dialog messages (modeless)
//*******************************************************************
#pragma argsused
BOOL CALLBACK HandleMainDialog(HWND hDlg, UINT message,
							   WPARAM wParam, LPARAM lParam)
{
	static RECT   wrect;
	int		x, y, w, h, mbret;
	char	cmd[256], opt[1024], fname[256];


	switch (message)
	{
		case WM_INITDIALOG:

			// Save the handle of this proc for use by main window proc.
			hDialogBox = hDlg;

			// Get position of dialog box window.
			GetWindowRect(hDlg, (LPRECT) &wrect);
			w = wrect.right - wrect.left;
			h = wrect.bottom - wrect.top;

			// Move main application window to same position.
			SetWindowPos(hWndMain, hDlg,
						 wrect.left, wrect.top, w, h,
						 0);

			read_ini();

			use_tree= FALSE;
			use_log= FALSE;
			use_hyp= FALSE;
			mode_test= FALSE;
			mode_verb= FALSE;
			use_symbol1= FALSE;
			use_symbol2= FALSE;
			use_symbol3= FALSE;
			mode_folder= FALSE;
			strcpy(symbol, "");
            strcpy(symbol2, "");
			strcpy(symbol3, "");

			strcpy(fsource, "");
			strcpy(fdest, "");

			destformat= ID_DMAIN_ASC;

			read_settings();

			SetDlgItemText(hDlg, ID_DMAIN_SOUR, (LPSTR) fsource );
			SetDlgItemText(hDlg, ID_DMAIN_DEST, (LPSTR) fdest );

			if (myCmdLine!=NULL)
			{	SetDlgItemText(hDlg, ID_DMAIN_SOUR, myCmdLine );
				GetDlgItemText(hDlg, ID_DMAIN_SOUR, fsource, MAX_FILE_LEN);
			}

			SendMessage(GetDlgItem(hDlg, destformat), BM_SETCHECK, TRUE, 0L);

			SendMessage(GetDlgItem(hDlg, ID_DMAIN_LOG), BM_SETCHECK, use_log, 0L);
			SendMessage(GetDlgItem(hDlg, ID_DMAIN_HYP), BM_SETCHECK, use_hyp, 0L);
			SendMessage(GetDlgItem(hDlg, ID_DMAIN_TREE), BM_SETCHECK, use_tree, 0L);
			SendMessage(GetDlgItem(hDlg, ID_DMAIN_TEST), BM_SETCHECK, mode_test, 0L);
			SendMessage(GetDlgItem(hDlg, ID_DMAIN_VERB), BM_SETCHECK, mode_verb, 0L);
			SendMessage(GetDlgItem(hDlg, ID_DMAIN_SYMBUT), BM_SETCHECK, use_symbol1, 0L);
			SendMessage(GetDlgItem(hDlg, ID_DMAIN_SYMBUT2), BM_SETCHECK, use_symbol2, 0L);
			SendMessage(GetDlgItem(hDlg, ID_DMAIN_SYMBUT3), BM_SETCHECK, use_symbol3, 0L);
			SendMessage(GetDlgItem(hDlg, ID_DMAIN_FOLDER), BM_SETCHECK, mode_folder, 0L);
			SetDlgItemText(hDlg, ID_DMAIN_SYMED, (LPSTR) symbol );
			SetDlgItemText(hDlg, ID_DMAIN_SYMED2, (LPSTR) symbol2 );
			SetDlgItemText(hDlg, ID_DMAIN_SYMED3, (LPSTR) symbol3 );

			adjust_dest(hDlg);
            adjust_lang(hDlg);

			SetFocus(GetDlgItem(hDlg, ID_DMAIN_SEXEC));
				
			break;

		case WM_MOVE:
			// Always keep this dialog box on top of main window.
			GetWindowRect(hWndMain, (LPRECT) &wrect);
			x = wrect.left;
			y = wrect.top;
			w = wrect.right - wrect.left;
			h = wrect.bottom - wrect.top;
			MoveWindow(hDlg, x, y, w, h, 1);
			break;

		case WM_SYSCOMMAND:
			// Pass WM_SYSCOMMAND messages on to main window so both
			// main window and dialog box get iconized, minimized etc.
			// in parallel.
			SendMessage(hWndMain, message, wParam, lParam);
			break;

		case WM_COMMAND:
			switch (wParam)
			{

				case ID_DMAIN_SOUR:
					GetDlgItemText(hDlg, ID_DMAIN_SOUR, fsource, MAX_FILE_LEN);
					break;

				case ID_DMAIN_SSEL:
					if ( select_source_file(hDlg, fname) )
					{   strcpy(fsource, fname);
						SetDlgItemText(hDlg, ID_DMAIN_SOUR, (LPSTR) fsource );
                        adjust_dest(hDlg);
                    }
                	break;

				case ID_DMAIN_SEDIT:
					GetDlgItemText(hDlg, ID_DMAIN_SOUR, fsource, MAX_FILE_LEN);
					if (fsource[0]=='\0')
					{	alert_source_missing(hDlg);
					}
					else
					{	exec_editor(hDlg, fsource);
					}
					break;
				
					
				case ID_DMAIN_DEST:
					GetDlgItemText(hDlg, ID_DMAIN_DEST, fdest, MAX_FILE_LEN);
					break;

				case ID_DMAIN_DSEL:
					if ( select_dest_file(hDlg, fname) )
					{	strcpy(fdest, fname);
						SetDlgItemText(hDlg, ID_DMAIN_DEST, (LPSTR) fdest );
						adjust_param(hDlg);
						adjust_result(hDlg);
                    }
                	break;

				case ID_DMAIN_DEXEC:
					GetDlgItemText(hDlg, ID_DMAIN_DEST, fdest, MAX_FILE_LEN);
					if (fdest[0]=='\0')
					{	alert_dest_missing(hDlg);
					}
					else
					{	exec_dest(hDlg, fdest);
					}
					break;

				case ID_DMAIN_DEDIT:
					GetDlgItemText(hDlg, ID_DMAIN_DEST, fdest, MAX_FILE_LEN);
					if (fdest[0]=='\0')
					{	alert_dest_missing(hDlg);
					}
					else
					{	exec_dest_edi(hDlg, fdest);
					}
					break;


				case ID_DMAIN_PEXEC:
					adjust_param(hDlg);
					if (fparam[0]!='\0')
					{	exec_param(hDlg, fparam);
					}
					break;

				case ID_DMAIN_PEDIT:
					adjust_param(hDlg);
					if (fparam[0]!='\0')
					{	exec_param_edi(hDlg, fparam);
					}
					break;


				case ID_DMAIN_REXEC:
					adjust_result(hDlg);
					if (fresult[0]!='\0')
					{	exec_result(hDlg, fresult);
					}
					break;

				case ID_DMAIN_REDIT:
					adjust_result(hDlg);
					if (fresult[0]!='\0')
					{	exec_result_edi(hDlg, fresult);
					}
					break;


				case ID_DMAIN_SEXEC:
					GetDlgItemText(hDlg, ID_DMAIN_SOUR, fsource, MAX_FILE_LEN);
					GetDlgItemText(hDlg, ID_DMAIN_DEST, fdest, MAX_FILE_LEN);
					adjust_param(hDlg);
					adjust_result(hDlg);

					if (fsource[0]!='\0' && fdest[0]!='\0')
					{
						// wenn der Zielpfad nicht existiert, fragen, ob er angelegt werden soll!

                        if ( check_dest_path(hDlg, fdest) )
                        {
							get_cli_option(opt);
							if (!use_log)	strcat(opt, " -l");
							if (!use_hyp)	strcat(opt, " -y");
							if (use_tree)	strcat(opt, " --tree");
							if (mode_test)	strcat(opt, " --test");
							if (mode_verb)	strcat(opt, " --verbose");
							if (use_symbol1 && (symbol[0]!='\0'))
							{
								strcat(opt, " -D ");
								strcat(opt, symbol);
                            }
							if (use_symbol2 && (symbol2[0]!='\0'))
							{
								strcat(opt, " -D ");
								strcat(opt, symbol2);
                            }
							if (use_symbol3 && (symbol3[0]!='\0'))
							{
								strcat(opt, " -D ");
								strcat(opt, symbol3);
							}
							sprintf(cmd, "%s -o %s",
											opt,
											fdest);
							exec_udo(hDlg, cmd, fsource);
                        }
					}
					else
					{	if (fsource[0]=='\0')
						{	alert_source_missing(hDlg);
						}
						if (fdest[0]=='\0')
						{	alert_dest_missing(hDlg);
						}
					}
					break;

				case ID_DMAIN_INFO:
					/*BWCC*/MessageBox(hDlg,
						"UDO Shell V0.08\n"
						__DATE__"\n"
						"(c) 1996, 1997 by Dirk Hagedorn\n"
						"Email: DirkHage@aol.com",
						"UDO Shell",
						MB_OK | MB_ICONINFORMATION);
						break;

				case ID_DMAIN_HELP:
					WinHelp(hDlg, "udosh.hlp", HELP_INDEX, NULL);
					break;

				case ID_DMAIN_ASC:
				case ID_DMAIN_AQV:
				case ID_DMAIN_HTM:
				case ID_DMAIN_TEX:
                case ID_DMAIN_HPH:
				case ID_DMAIN_LDS:
				case ID_DMAIN_MAN:
				case ID_DMAIN_NRO:
				case ID_DMAIN_PCH:
				case ID_DMAIN_RTF:
				case ID_DMAIN_STG:
				case ID_DMAIN_INF:
				case ID_DMAIN_TVH:
				case ID_DMAIN_WIN:
				case ID_DMAIN_LYX:
				case ID_DMAIN_SRC:
				case ID_DMAIN_SRP:
					destformat= wParam;
					adjust_dest(hDlg);
					break;

				case ID_DMAIN_LOG:
					use_log= SendMessage(GetDlgItem(hDlg, wParam), BM_GETCHECK, 0, 0L);
					break;
				
				case ID_DMAIN_LOGEDIT:
					if (use_log && flog[0]!='\0')
					{	exec_editor(hDlg, flog);
					}
					break;

				case ID_DMAIN_HYP:
					use_hyp= SendMessage(GetDlgItem(hDlg, wParam), BM_GETCHECK, 0, 0L);
					break;

				case ID_DMAIN_HYPEDIT:
					if (use_hyp && fhyp[0]!='\0')
					{	exec_editor(hDlg, fhyp);
					}
					break;

				case ID_DMAIN_TREE:
					use_tree= SendMessage(GetDlgItem(hDlg, wParam), BM_GETCHECK, 0, 0L);
					break;

				case ID_DMAIN_TREEEDIT:
					if (use_tree && ftree[0]!='\0')
					{	exec_editor(hDlg, ftree);
					}
					break;

				case ID_DMAIN_TEST:
					mode_test= SendMessage(GetDlgItem(hDlg, wParam), BM_GETCHECK, 0, 0L);
					break;
					
				case ID_DMAIN_VERB:
					mode_verb= SendMessage(GetDlgItem(hDlg, wParam), BM_GETCHECK, 0, 0L);
					break;

				case ID_DMAIN_SYMBUT:
					use_symbol1= SendMessage(GetDlgItem(hDlg, wParam), BM_GETCHECK, 0, 0L);
					break;

				case ID_DMAIN_SYMBUT2:
					use_symbol2= SendMessage(GetDlgItem(hDlg, wParam), BM_GETCHECK, 0, 0L);
					break;

				case ID_DMAIN_SYMBUT3:
					use_symbol3= SendMessage(GetDlgItem(hDlg, wParam), BM_GETCHECK, 0, 0L);
					break;

				case ID_DMAIN_FOLDER:
					mode_folder= SendMessage(GetDlgItem(hDlg, wParam), BM_GETCHECK, 0, 0L);
                    adjust_dest(hDlg);
					break;

				case ID_DMAIN_SYMED:
					GetDlgItemText(hDlg, ID_DMAIN_SYMED, symbol, MAX_FILE_LEN);
                    break;

				case ID_DMAIN_SYMED2:
					GetDlgItemText(hDlg, ID_DMAIN_SYMED2, symbol2, MAX_FILE_LEN);
                    break;

				case ID_DMAIN_SYMED3:
					GetDlgItemText(hDlg, ID_DMAIN_SYMED3, symbol3, MAX_FILE_LEN);
                    break;

				case ID_DMAIN_LANG:
					mbret= /*BWCC*/MessageBox(hDlg,
						"Deutschsprachiges GUI benutzen?\n"
						"Use German GUI?\n",
						"UDO Shell",
						MB_YESNOCANCEL | MB_ICONQUESTION);

					switch (mbret)
					{
						case IDYES:
							if (guilang!=GUIGER)
							{	guilang= GUIGER;
								adjust_lang(hDlg);
                                InvalidateRect(hDlg, NULL, TRUE);
							}
                            break;
						case IDNO:
							if (guilang==GUIGER)
							{	guilang= GUIENG;
                            	adjust_lang(hDlg);
								InvalidateRect(hDlg, NULL, TRUE);
							}
                            break;
					}
                    break;


				case ID_DMAIN_EXIT:
                	SendMessage(hDlg, WM_CLOSE, 0, 0L);
                	break;

				default:
					break;
			}
			break;

		case WM_CLOSE:
			// Unlock dialog resource we locked above.
			UnlockResource(hdlgr);

			// Free it.
			FreeResource(hdlgr);

			// Zero handle to it.
			hdlgr = 0;

			// Zero handle to this dialog window.
			hDialogBox = 0;

			// Tell main window to close.
			PostMessage(hWndMain, WM_CLOSE, 0, 0L);

			// Destroy ourseleves.
			DestroyWindow(hDlg);
			break;

		default:
			return FALSE;
	}

	return(TRUE);
}

